//
//  MyDocument.m
//  YKQTKitCapture
//
//  Created by KOYAMA Yoshiaki on 05/09/08.
//  Copyright KOYAMA Yoshiaki 2005 . All rights reserved.
//

#import "MyDocument.h"
#import <QTKit/QTKit.h>

pascal Boolean MyActionFilter (MovieController mc, short action, void* params, long refCon);

@implementation MyDocument

- (id)init
{
    self = [super init];
    if (self) {
		_count = 0;
    }
    return self;
}

- (NSString *)windowNibName
{
    // Override returning the nib file name of the document
    // If you need to use a subclass of NSWindowController or if your document supports multiple NSWindowControllers, you should remove this method and override -makeWindowControllers instead.
    return @"MyDocument";
}

- (void)windowControllerDidLoadNib:(NSWindowController *) aController
{
	QTMovie *movie;
	NSError *theError;

	[super windowControllerDidLoadNib:aController];

    if (_type != nil) {
//		movie = [QTMovie movieWithData:_data error:nil];
		movie = [QTMovie movieWithURL:[self fileURL] error:&theError];
		[_captureMovieView setMovie:movie];
		[_captureMovieView setControllerVisible:YES];
		[_captureMovieView setEditable:YES];

		if (movie) {
			[self installMovieIdleCallback];
		}
    }
}

- (NSData *)dataRepresentationOfType:(NSString *)aType
{
   if (aType != nil) {
		return [[_captureMovieView movie] movieFormatRepresentation];
    }

    return nil;
}

- (BOOL)loadDataRepresentation:(NSData *)data ofType:(NSString *)aType
{ 
	_data = [data retain];
    _type = [aType retain];
   
    return YES;
}

// ̉
- (void)dealloc {
//    [[NSNotificationCenter defaultCenter] removeObserver:self];

    [_data release];
    [_type release]; 
    [_image release]; 

    [super dealloc];
}

- (IBAction)captureImage:(id)sender {
	QTMovie *movie;
    NSPasteboard *board = [NSPasteboard generalPasteboard];
	NSArray *array;
	
	[_image release];

	movie = [_captureMovieView movie];
	_image = [movie currentFrameImage];
	[_image retain];

//	_image = [[_captureMovieView movie] posterImage];

	if (_image != nil) {
		[_imageButton setImage:_image];

		// Nbv{[hɃRs[
		array = [NSArray arrayWithObject:NSTIFFPboardType];
		[board declareTypes:array owner:nil];
		[board setData:[_image TIFFRepresentation] forType:NSTIFFPboardType];
	}
}

- (IBAction)saveImage:(id)sender {
	NSSavePanel *panel;
	NSURL *url;
	NSString *strUrl;
	NSString *name;
//	int returnCode;

	url = [self fileURL];
	strUrl = [url absoluteString];
	name = [[strUrl lastPathComponent] stringByDeletingPathExtension]; 
	name = [NSString stringWithFormat:@"%@_%d", name, _count]; 
	name = [name stringByAppendingPathExtension:@"tiff"];

	panel = [NSSavePanel savePanel];

/*	[panel setNameFieldLabel:name];
	[panel setDirectory:NSHomeDirectory() ];
	returnCode = [panel runModal];

	if (returnCode == NSFileHandlingPanelCancelButton) {
		NSLog("cancel");
	} else if (returnCode == NSFileHandlingPanelOKButton) {
		NSLog(@"ok");
	}
*/
	[panel beginSheetForDirectory:NSHomeDirectory() 
		file:name modalForWindow:_docWindow modalDelegate:self 
		didEndSelector:@selector(savePaneltDidEnd:returnCode:contextInfo:) contextInfo:nil];

}


- (void)savePaneltDidEnd:(NSSavePanel *)panel returnCode:(int)returnCode
    contextInfo:(void *)contextInfo {
	NSData *data;
	NSString *path;
	BOOL flag;

	if (returnCode == NSFileHandlingPanelCancelButton) {
	} else if (returnCode == NSFileHandlingPanelOKButton) {
		data = [_image TIFFRepresentation];

		path = [[panel URL] path]; 
		flag = [data writeToFile:path atomically:YES];

		if (flag == YES) {
			_count++;
		}
	}
}


-(void)installMovieIdleCallback {
    ComponentResult cr = noErr;
    MovieController mc = [[_captureMovieView movie] quickTimeMovieController];

    if (!mc) goto bail;
    MCActionFilterWithRefConUPP upp = NewMCActionFilterWithRefConUPP(MyActionFilter);
    if (!upp) goto bail;
		cr = MCSetActionFilterWithRefCon(mc, upp, (long)self);
    DisposeMCActionFilterWithRefConUPP(upp);
bail:

    return;
}

-(void)removeMovieIdleCallback {

    MCSetActionFilterWithRefCon([[_captureMovieView movie] quickTimeMovieController],
                                nil,
                                (long)self);
}

- (void)setTimeDisplay {
    if (_data != nil) {
        QTTime currentPlayTime = [[[_captureMovieView movie] attributeForKey:QTMovieCurrentTimeAttribute] QTTimeValue];
        [_timeDisplay setStringValue:QTStringFromTime(currentPlayTime)];
    }
}

- (IBAction)actuallySize:(id)sender {
	QTMovie *movie;
	NSSize size;

	movie = [_captureMovieView movie];

	if (movie != nil) {

		size = [[movie attributeForKey:QTMovieNaturalSizeAttribute] sizeValue];

		size.width += 10;
		size.height = size.height + 180 + 17 + 37;

		[_docWindow setContentSize:size];
	}
}

- (IBAction)defaultSize:(id)sender {
	[_docWindow setContentSize:NSMakeSize(330,414)];
}

- (BOOL)validateMenuItem:(NSMenuItem *)menuItem {
    BOOL valid = NO;
    SEL action;

    action = [menuItem action];

    if (action == @selector(saveImage:)) {
        valid = (_image != nil);
//    } else if (action == @selector(doShowController:)) {
//        [menuItem setState:([mMovieView isControllerVisible] ? NSOnState : NSOffState)];
//        valid = YES;
    } else {
        valid = [super validateMenuItem:menuItem];
	}
    return valid;
}

@end

pascal Boolean MyActionFilter (MovieController mc, short action, void* params, long refCon) {
    MyDocument *doc = (MyDocument *)refCon;
    switch (action) 
    {
        // handle idle events
        case mcActionIdle:
			[doc setTimeDisplay];
		break;            
    }
    return false;
}

